/*
 *  ======== getLibs ========
 */
function getLibs( prog )
{
    var ompSettings = xdc.module("ti.runtime.openmp.Settings");

    /* _args_main redefined in BIOS mode only when not on OpenCL mode */
    if (ompSettings.usingRtsc == false || ompSettings.usingOpenCL == true)
        return (null);

    var pkg = this;
    var suffix = prog.build.target.findSuffix(pkg);
    var debugFlag = "_debug";
 

    if (this.profile == "release")
        debugFlag = "_release"
 
    lib = "lib/" + pkg.$name.replace(/\./g, "_") + debugFlag +  
                "_" + suffix + ".a" + suffix;

    if (java.io.File(this.packageBase + lib).exists())
    {
        return lib;
    }
    else 
    {
         /* could not find any library, throw exception */
         throw new Error("Library not found: " + lib);
    }
}

