/*
 *  ======== getSects ========
 */
function getSects()
{
    return "ti/runtime/cio/linkcmd.xdt";
}

/*
 *  ======== getLibs ========
 */
function getLibs( prog )
{
    var pkg = this;
 
    var suffix = prog.build.target.findSuffix(pkg);
    var debugFlag = "_debug";
 
    if (this.profile == "release")
        debugFlag = "_release"

    // If used along with OpenCL, use device specific code from OpenCL monitor
    // Also, if application initializes QMSS, pick up QMSS device files and
    // OSAL from the application.
    var ompSettings = xdc.module("ti.runtime.openmp.Settings");
    if (ompSettings.usingOpenCL == true)
        return (null);

    var target;
    if( String(Program.cpu.deviceName).search("663") != -1)
    {
        target = "_c6636";
    }
    else
    {
        Program.$logError("Device:" + Program.cpu.deviceName + 
                          " not supported", this);
    }

    lib = "lib/" + pkg.$name.replace(/\./g, "_") + target + debugFlag +  
                "_" + suffix + ".a" + suffix;

    if (java.io.File(this.packageBase + lib).exists())
    {
        return lib;
    }
    else
    {
         /* could not find any library, throw exception */
         throw new Error("Library not found: " + lib);
    }
}

