/*! Configure top-level OpenMP runtime parameters */
metaonly module Settings {
 
    enum DebugFlag 
    {
        DEBUG,
        RELEASE
    };

    /*! Set to true if application includes or depends on RTSC compoments */
    config Bool usingRtsc = false;

    /*! @_nodoc Set to true if OpenMP runtime is used along with OpenCL */
    config Bool usingOpenCL = false;

    /*! Set to false if the application will intialize QMSS. OpenMP startup 
     *  function __TI_omp_start[_bios_mode] requires QMSS to be initialized
     *  via Qmss_init().
     */
    config Bool runtimeInitializesQmss = true;

    /*! @_nodoc Internal debug/release flag */
    config DebugFlag debugFlag;
}

